import Obj

main = interact $ showObj . concatMap label . map roll . readObj

roll (NX [x,y,z]) = NX [r*sin theta, y, r*cos theta]
  where theta = 2*pi*x/c
roll line = line

c = 0.280 -- circumference
s = 2 -- scaling factor
r = s*c/(2*pi)

label (NX [x,y,z]) | y < 0+eps = [NX [x,y,z], NL 1]
label (NX [x,y,z]) | y > h-eps = [NX [x,y,z], NL 2]
label line = [line]

h = 0.216 -- height
eps = 1e-3
